
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 neuron <neuron@hollowtube.mine.nu>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include "../../src/initng_active_db.h"
#include "../../src/initng_system_states.h"
#include "../../src/initng_list.h"
#include "ngcs_common.h"

#include <stddef.h>

typedef struct ngcs_cmd_s ngcs_cmd;
typedef struct ngcs_channel_s ngcs_channel;
typedef struct ngcs_conn_s ngcs_conn;

int module_init(const char *version);
void module_unload(void);

int service_status(active_db_h * service);
void is_system_halt(h_sys_state state);

void ngcs_close_channel(ngcs_channel * chan);
void ngcs_reg_cmd(ngcs_cmd * cmd);
int ngcs_channel_send(ngcs_channel * chan, ngcs_data * data, int cnt);

struct ngcs_cmd_s
{
    const char *name;
    void (*connect) (ngcs_channel *, ngcs_data *, int);
    void (*gotdata) (ngcs_channel *, ngcs_data *, int);
    void (*free) (ngcs_channel *);
    struct list_head list;
};

struct ngcs_channel_s
{
    int id;
    ngcs_cmd *cmd;
    ngcs_conn *conn;
    void *user_data;
    struct list_head list;
};

struct ngcs_conn_s
{
    f_module_h fdw;
    ngcs_channel chans;
    int nextid;
    struct list_head list;
};


extern ngcs_conn ngcs_conns;
extern ngcs_conn ngcs_dead_conns;
extern ngcs_cmd ngcs_cmds;

#define while_ngcs_conns(current) list_for_each_entry_prev(current, &ngcs_conns.list, list)
#define while_ngcs_conns_safe(current, safe) list_for_each_entry_prev_safe(current, safe, &ngcs_conns.list, list)

#define while_ngcs_dead_conns(current) list_for_each_entry_prev(current, &ngcs_dead_conns.list, list)
#define while_ngcs_dead_conns_safe(current, safe) list_for_each_entry_prev_safe(current, safe, &ngcs_dead_conns.list, list)

#define while_ngcs_chans(current, conn) list_for_each_entry_prev(current, &(conn)->chans.list, list)
#define while_ngcs_chans_safe(current, safe, conn) list_for_each_entry_prev_safe(current, safe, &(conn)->chans.list, list)

#define while_ngcs_cmds(current) list_for_each_entry_prev(current, &ngcs_cmds.list, list)
#define while_ngcs_cmds_safe(current, safe) list_for_each_entry_prev_safe(current, safe, &ngcs_cmds.list, list)
