/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef INITNG_PLIST_H
#define INITNG_PLIST_H

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

typedef struct
{
    unsigned int alloc_heap;
    unsigned int allocated;
    unsigned int next_to_set;
    void **list;
} plist_h;

typedef struct
{
    plist_h *plist;
    unsigned int count;
} pit_h;

#define PLIST_INIT(plist, heap) { (plist)->allocated=0; (plist)->next_to_set=0; (plist)->list=NULL; (plist)->alloc_heap = (heap); }

int plist_add(void *pointer, plist_h * plist);
int plist_del(void *pointer, plist_h * plist);
void plist_clear(plist_h * plist);

/* initziates an itterator with a plist */
#define PIT_INIT(pl, pit) { (pit)->plist = (pl); (pit)->count = 0; }

/* get the value from an itterator */
#define V(pit) (pit)->plist->list[(pit)->count]

/* walks the itterator */
#define FOR_LIST(pit) for((pit)->count=0; (pit)->plist->list && (pit)->count < (pit)->plist->next_to_set; (pit)->count++)
#define FOR_LIST_REW(pit) for((pit)->count=(pit)->plist->next_to_set-1; (pit)->plist->list && (pit)->count >= 0 ; (pit)->count--)
#endif
