#include <stdio.h>
#include <stdlib.h>
#include "../src/initng_plist.h"
#include "../src/initng_plist.c"

plist_h main_l;

static add(char *name)
{
    printf("\n\nAdding %s to main\n", name);
    plist_add(name, &main_l);
    printf("main_l: allocated = %i, next_to_set = %i, alloc_heap = %i\n",
           main_l.allocated, main_l.next_to_set, main_l.alloc_heap);
}

static print_all(void)
{
    int i;
    char *string;
    pit_h itterator;

    printf("\n\n");

    PIT_INIT(&main_l, &itterator);
    FOR_LIST(&itterator)
    {
        printf("main: %s\n", V(&itterator));

    }
    printf("\n\n");
}

static del_all(void)
{
    pit_h itterator;

    printf("\n\n");

    PIT_INIT(&main_l, &itterator);
    FOR_LIST(&itterator)
    {
        printf("main_del: %s\n", (char *) V(&itterator));
        plist_del(V(&itterator), &main_l);
        printf("main_l: allocated = %i, next_to_set = %i, alloc_heap = %i\n",
               main_l.allocated, main_l.next_to_set, main_l.alloc_heap);

    }

    printf("\n\n");
}

static del_all_rew(void)
{
    pit_h itterator;

    printf("\n\n");

    PIT_INIT(&main_l, &itterator);
    FOR_LIST_REW(&itterator)
    {
        printf("main_del: %s\n", (char *) V(&itterator));
        plist_del(V(&itterator), &main_l);
        printf("main_l: allocated = %i, next_to_set = %i, alloc_heap = %i\n",
               main_l.allocated, main_l.next_to_set, main_l.alloc_heap);

    }

    printf("\n\n");
}

static fill(void)
{
    const char *statica = "Statica";

    add("Anna");
    add("Berit");
    add("Cesar");
    add("David");
    add("Erica");
    add("Fredelina");
    plist_add((void *) statica, &main_l);
    add("Gtesvea");
    add("Henrikia");
    add("Inga");

}

int main(int argc, const char **argv)
{
    PLIST_INIT(&main_l, 4);
    printf("Hello\n\n");
    print_all();
    fill();
    print_all();
    del_all();
    print_all();
    fill();
    print_all();
    del_all_rew();
    print_all();
    return (0);
}
